


 #include "s52prg.h"

//------------------------------------------------------------------

void setup() {
  // put your setup code here, to run once:

 start_linecfg(); // начальная конфигурация управляющих выводов
 // зажечь штатный светодиод как индикацию
 // ожидания запуска терминальной программы в ПК
 digitalWrite(LED_BUILTIN, HIGH); pinMode(LED_BUILTIN, OUTPUT);
 Serial.begin(9600);
 dump_size=sizeof(b2b_dump);
 wait_s_Key();
 digitalWrite(LED_BUILTIN, LOW); delay(200); // погасить базовый светик адуринки
 
}

//------------------------------------------------------------------

void loop() {
  // put your main code here, to run repeatedly:

restart:
 start_linecfg(); // установка начальных параметров для установки/снятия МК
 Serial.println(F("bios b52m KOTUINKO programmer"));
 Serial.println(F("Install AT89S52 in jack with zero effort and press button of management"));
 wait_s_Key();
// стартовая конфигурация выводов
/*
 *  PG_RST = выход с предвведенной 1
 *  SCK_CLK = выход с предвведенным 0
 *  DOut = выход с предвведенным 0
 *  DInp = вход пуллап с предвведенной 1
 *  PG_LED = выход 1
 *  S_Key = вход пуллап
 */
 digitalWrite(PG_LED, LOW); // включить PG_LED
  // ждать паузу установки сброса в >= 64 sys_CLK
 pinMode(PG_RST, OUTPUT); delay(sw_time); // 1
 digitalWrite(PG_RST, LOW); delay(sw_time); // 0
 digitalWrite(PG_RST, HIGH); delay(sw_time); // 1
 pinMode(SCK_CLK, OUTPUT);
 pinMode(DOut, OUTPUT); pinMode(DInp, INPUT_PULLUP);
  // выдать команду programming enable
 tx_tmp=B10101100; tr_spi();
 tx_tmp=B01010011; tr_spi();
 tx_tmp=0; tr_spi(); tr_spi();
  // и проверить результат
 if (rx_tmp==B01101001)
 {
  // выдать сообщение "режим программирования активирован"
  Serial.println(F("mode of the programming is actuated")); // и продолжить
 }
  else if (rx_tmp!=B01101001)
  {
    // иначе выдать сообщение "ошибка активации режима ISP"
   Serial.println(F("ERROR to activations of the ISP mode"));
   digitalWrite(PG_LED, HIGH); // погасить индикатор PG_LED
    goto restart; // и аварийный перезапуск
  }

// читать и вывести на терминал сигнатуру МК
 tx_tmp=B00101000; tr_spi();
 tx_tmp=0; tr_spi(); tr_spi(); tr_spi();
 Serial.print(F("signature 000H = ")); Serial.println(rx_tmp, HEX);
 tx_tmp=B00101000; tr_spi();
 tx_tmp=1; tr_spi(); tx_tmp=0; tr_spi(); tr_spi();
 Serial.print(F("signature 100H = ")); Serial.println(rx_tmp, HEX);
 switch (rx_tmp) {
    case 0x51:
      flash_size=flash_size_51;
      // сообщение "АТ89S51 не соответствует требованиям текущей программы"
      Serial.println(F("AT89S51 does not be up to quality current program"));
      break;
    case 0x52:
      flash_size=flash_size_52;
      Serial.println(F("AT89S52"));
      break;
    default:
      // отработка аварийного несоответствия
      Serial.println(F("????? does not be up to quality current program"));
      digitalWrite(PG_LED, HIGH); // погасить индикатор PG_LED
      goto restart;
    break;
  }

 tx_tmp=B00101000; tr_spi();
 tx_tmp=2; tr_spi(); tx_tmp=0; tr_spi(); tr_spi();
 Serial.print(F("signature 200H = ")); Serial.println(rx_tmp, HEX);

// читать и вывести на терминал статус LOC-bit
 tx_tmp=B00100100; tr_spi();
 tx_tmp=0; tr_spi(); tr_spi(); tr_spi();
 tmp_LB=rx_tmp&B00011100;
 Serial.print(F("LB1 = ")); Serial.println(bitRead(rx_tmp, 2), DEC);
 Serial.print(F("LB2 = ")); Serial.println(bitRead(rx_tmp, 3), DEC);
 Serial.print(F("LB3 = ")); Serial.println(bitRead(rx_tmp, 4), DEC);
 wait_s_Key();

// если необходимо, стирание LOC-bit
 if (tmp_LB)
 {
  Serial.println(F("it is executed unset LB3:LB1"));
  tx_tmp=B10101100; tr_spi(); tx_tmp=B11100000; tr_spi();
  tx_tmp=0; tr_spi(); tr_spi();
  delay(sw_time);
   // проверка содержимого после операции
  tx_tmp=B00100100; tr_spi();
  tx_tmp=0; tr_spi(); tr_spi(); tr_spi();
  tmp_LB=rx_tmp&B00011100;
   if (!tmp_LB)
   {
    Serial.println(F("LB3:LB1=0:0:0"));
   }
    else 
    {
     Serial.println(F("unset LB3:LB1 ERROR"));
    }
 }

 cler_test_b(); // выполнить проверку чистоты флэш-памяти
 // если не пуста то выполнить стирание кристалла
 if (er_flag)
 {
  Serial.println(F("Chip Erase is executed"));
  tx_tmp=B10101100; tr_spi(); tx_tmp=B10000000; tr_spi();
  tx_tmp=0; tr_spi(); tr_spi(); er_flag=0;
  delay(650); // по даташиту 500ms ставим "с запасом"
  cler_test_p(); // выполнить проверку чистоты флэш-памяти
   if (er_flag)
   {
    Serial.println(F(" mistake after operation of the deleting "));
    goto restart;
   }
 }
 // если "чистая" общее стирание не выполняется
 if (!er_flag)
 {
  Serial.println(F("  test OK"));
 }

 wait_s_Key();

// постраничная запись дампа в ПЗУ с последующей верификацией
 Serial.println(F("page writing the dump with simultaneous verification"));
  er_flag=0; prog_cnt=0; wait_flag=1; // str_cnt=0; 
 Serial.print(prog_cnt, HEX); Serial.print(F(":"));
 do
 {
  // запись страницы
  tx_tmp=B01010000; tr_spi(); tx_tmp=highByte(prog_cnt); tr_spi();
  for (int cntp=0; cntp<=255; cntp++)
  {
   tx_tmp = pgm_read_byte_near(b2b_dump+prog_cnt); tr_spi();
   prog_cnt++;
  }
  delay(sw_time); // пауза интервала записи
  t_prog_cnt = prog_cnt-256; // дубликат начального адреса страницы в t_prog_cnt
  // обратное чтение данных в буфер
  tx_tmp=B00110000; tr_spi(); tx_tmp=highByte(t_prog_cnt); tr_spi();
  for (int cntp=0; cntp<=255; cntp++)
  {
   tx_tmp=0; tr_spi();
   tmp_page[cntp]=rx_tmp;
  }
  // верификация считанных данных
  for (int cntp=0; cntp<=255; cntp++)
   {
    if (tmp_page[cntp] != pgm_read_byte_near(b2b_dump+t_prog_cnt))
     {
      er_flag=1; wait_flag=0; // досрочное завершение теста
      Serial.print(F("ERROR on ")); Serial.print(t_prog_cnt,HEX);
      Serial.print(F(" : ")); Serial.print(rx_tmp,HEX); Serial.print(F(" != "));
      Serial.println(pgm_read_byte_near(b2b_dump+t_prog_cnt),HEX); break;
     }
   t_prog_cnt++;
   }
  if (prog_cnt == dump_size){wait_flag=0; Serial.println(F("*"));}
  if (wait_flag)
    {
     Serial.println(F("*"));
     Serial.print(prog_cnt, HEX); Serial.print(F(":"));
    }
 } while (wait_flag);
  if (!er_flag)
  {
   Serial.println(F(" "));
   Serial.println(F("boot to memories of the programs successfully completed"));
  }

 wait_s_Key();

}

//------------------------------------------------------------------
/*
 * DOut = вход z с предвведенным 0
 * DInp = вход пуллап с предвведенной 1
 * SCK_CLK = вход z с предвведенным 0
 * PG_RST = вход пуллап с предвведенной 1
 * PG_LED = выход 1
 * S_Key = вход пуллап с предвведенной 1
*/
void start_linecfg()
{
 digitalWrite(DOut, LOW); digitalWrite(SCK_CLK, LOW);
 digitalWrite(DInp, HIGH); digitalWrite(PG_RST, HIGH);
 digitalWrite(PG_LED, HIGH); digitalWrite(S_Key, HIGH);
 pinMode(DOut, INPUT); pinMode(SCK_CLK, INPUT);
 pinMode(PG_RST, INPUT); pinMode(PG_LED, OUTPUT);
 pinMode(DInp, INPUT); pinMode(S_Key, INPUT_PULLUP);
}

//------------------------------------------------------------------

unsigned int blok_cnt_size(unsigned int dumpp_size)
{
 unsigned int tmp=dumpp_size/256;
 if (dumpp_size%256)
 {
  tmp++;
 }
 return tmp;
}

//------------------------------------------------------------------
// функция пересылки одного байта
// одновременно и передает и принимает байт старшими битами вперед

void tr_spi()
{ byte tr_ptr =7;
  for (byte cnt =0; cnt<=7; cnt++)
  {
   digitalWrite(DOut, bitRead(tx_tmp, tr_ptr));
   delayMicroseconds(15);
  // delay(clk_qvot);
   digitalWrite(SCK_CLK, HIGH);
   delayMicroseconds(20);
  // delay(clk_qvot);
   bitWrite(rx_tmp, tr_ptr, digitalRead(DInp));
   delayMicroseconds(5);
  // delay(clk_qvot);
   digitalWrite(SCK_CLK, LOW);
   delayMicroseconds(15);
  // delay(clk_qvot);
   tr_ptr--;
  }
}

//------------------------------------------------------------------
// заставка и ожидание нажатия S_Key для продолжения

void wait_s_Key()
{
 Serial.println(F("for gou continuation press button of management"));
 digitalWrite(PG_LED, HIGH); // погасить индикатор PG_LED
 // контроль нажатия S_Key
  wait_flag=1;
 do
 {
  if (!digitalRead(S_Key))
  {
    delay(100);
    if (!digitalRead(S_Key)){wait_flag = 0;}
  }
 } while (wait_flag);
 // контроль отпускания S_Key
  wait_flag=1;
 do
 {
  if (digitalRead(S_Key))
  {
    delay(100);
    if (digitalRead(S_Key)){wait_flag = 0;}
  }
 } while (wait_flag);
}

//------------------------------------------------------------------
// проверка "чистоты" ПЗУ после цикла записи - постраничная
// применять только после операции общего стирания иначе
// возвращает недостоверный результат байта содержащего ошибку

void cler_test_p()
{
  // выполнить проверку чистоты флэш-памяти
 Serial.println(F(" page test cleaning to Program Memories "));
  er_flag=0; prog_cnt=0; wait_flag=1; // str_cnt=0;
 Serial.print(prog_cnt, HEX); Serial.print(F(":"));
 do
{
 // обратное чтение данных в буфер
  tx_tmp=B00110000; tr_spi(); tx_tmp=highByte(prog_cnt); tr_spi();
  for (int cntp=0; cntp<=255; cntp++)
  {
   tx_tmp=0; tr_spi();
   tmp_page[cntp]=rx_tmp;
  }
  for (int cntp=0; cntp<=255; cntp++)
  {
   if(tmp_page[cntp] != 0xFF)
    {
    er_flag=1; wait_flag=0; // досрочное завершение теста
    Serial.print(F("  ERROR on  ")); Serial.print(prog_cnt,HEX);
    Serial.print(F(" : ")); Serial.print(rx_tmp,HEX); Serial.print(F(" != "));
    Serial.println(0xFF,HEX); break;
    }
   prog_cnt++;
  }
  if (prog_cnt == dump_size){wait_flag=0; Serial.println(F("*"));}
  if (wait_flag)
    {
     Serial.println(F("*"));
     Serial.print(prog_cnt, HEX); Serial.print(F(":"));
    }
 } while (wait_flag); 
}

//------------------------------------------------------------------
// проверка "чистоты" ПЗУ - побайтовая
// применяется в первичном контроле содержимого ПЗУ

void cler_test_b()
{
  // выполнить проверку чистоты флэш-памяти
 Serial.println(F(" byte test cleaning to Program Memories "));
  er_flag=0; prog_cnt=0; str_cnt=0; wait_flag=1;
 Serial.print(prog_cnt, HEX); Serial.print(F(":"));
 do
{
  tx_tmp=B00100000; tr_spi(); tx_tmp=highByte(prog_cnt); tr_spi();
  tx_tmp=lowByte(prog_cnt); tr_spi();
  tx_tmp=0; tr_spi();
  if (rx_tmp != 0xFF)
  {
   er_flag=1; wait_flag=0; // досрочное завершение теста
   Serial.print(F("  ERROR on  ")); Serial.print(prog_cnt,HEX);
   Serial.print(F(" : ")); Serial.print(rx_tmp,HEX); Serial.print(F(" != "));
   Serial.println(0xFF,HEX);
  }
  prog_cnt++; str_cnt++;
  if (prog_cnt == dump_size){wait_flag=0; Serial.println(F("*"));}
  if (str_cnt==256)
  {
    str_cnt=0;
    if (wait_flag)
    {
     Serial.println(F("*"));
     Serial.print(prog_cnt, HEX); Serial.print(F(":"));
    }
   }
 } while (wait_flag);
}

//------------------------------------------------------------------




//------------------------------------------------------------------



//-------------конец файла/end of file---------------------
